#import <CoreFoundation/CoreFoundation.h>
//#import <ApplicationServices/ApplicationServices.h>
#import <CoreGraphics/CGContext.h>
#import <UIKit/UIKit.h>
#import <UIKit/UITextView.h>
#import <UIKit/UIFont.h>
//#import <NSGraphicsContext.h>
#import <math.h>
#import "afficheSinu.h"

@implementation afficheSinu

@synthesize arrayPoints;
@synthesize arraySize;
@synthesize lineWidth;
@synthesize nbPoints;

- (id)init {
	self = [super init];
	arrayPoints = [[NSMutableArray alloc] initWithCapacity: nbPoints];
	arraySize = 0;
	return self;
}

- (id)initWithFrame:(CGRect )frame {
	self = [super initWithFrame: frame];
	arrayPoints = [[NSMutableArray alloc] initWithCapacity: nbPoints];
	arraySize = 0;
	return self;
}
-(void)clear {
	[arrayPoints removeAllObjects];
	arraySize = 0;
}
-(void)addPoint:(CGFloat) point {
	NSNumber *nb = [NSNumber numberWithFloat: point];
	if (arraySize == nbPoints)
		[arrayPoints removeObjectAtIndex:0];
	else 
		arraySize ++;

	[arrayPoints addObject:nb];
	[self setNeedsDisplay];
}
-(void)drawRect:(CGRect)rect
{
	CGRect imgRect = [self bounds];
 	CGContextRef context = UIGraphicsGetCurrentContext();
	[[UIColor whiteColor] set];

	CGFloat orig=(imgRect.size.width-50)/255;
	CGFloat x=50;//imgRect.size.width/255;
	CGFloat decalY = imgRect.size.height/(nbPoints-10);

	CGContextSetRGBFillColor (context, 0, 0, 0, 1);
	CGContextSetRGBStrokeColor(context,1,1,1,1);

	CGContextFillRect (context, imgRect);// 4
	UIRectFrame(imgRect);
	int i;
	CGContextBeginPath (context);
	NSNumber *nb;
	NSNumber *nb1;

	for (i=1;i<arraySize;i++) {
		//something
		nb = [arrayPoints objectAtIndex:i];
		nb1 = [arrayPoints objectAtIndex:i-1];
	    CGContextMoveToPoint(context, x+[nb1 floatValue]*orig, (i-1)*decalY);

	    CGContextAddLineToPoint(context, x+[nb floatValue]*orig,i*decalY);
	}
	CGContextStrokePath(context);
}
- (void) refresh {
	[self setNeedsDisplay]; 
}
@end

