#import <CoreFoundation/CoreFoundation.h>
//#import <ApplicationServices/ApplicationServices.h>
#import <CoreGraphics/CGContext.h>
#import <UIKit/UIKit.h>
#import <UIKit/UITextView.h>
#import <UIKit/UIFont.h>
#import <NSGraphicsContext.h>
#import <math.h>
#import "sendBt.h"
#import "BTDevice.h"
#include <btstack/btstack.h>
#include <btstack/run_loop.h>
#include <btstack/hci_cmds.h>
#include <BTstackManager.h>
double pas;
static inline double radians (double degrees) {return degrees * M_PI/180;}
NSTimer *timer;
int main(int argc, char **argv) {
	pas = 0;
    NSAutoreleasePool *autoreleasePool = [
        [ NSAutoreleasePool alloc ] init 
    ];

    int returnCode = UIApplicationMain(argc, argv, @"sendBt", @"sendBt");
    [ autoreleasePool release ];
    return returnCode;
}

@implementation sendBt


char tmp[255];
int nb=0;
int received=0;
char data_out[255];
-(void) rfcommConnectionCreatedAtAddress:(bd_addr_t)addr 
						forChannel:(uint16_t)channel asID:(uint16_t)connectionID{}
-(void) rfcommConnectionCreateFailedAtAddress:(bd_addr_t)addr 
						forChannel:(uint16_t)channel error:(BTstackError)error{}
-(void) rfcommConnectionClosedForConnectionID:(uint16_t)connectionID{}
-(void) rfcommDataReceivedForConnectionID:(uint16_t)connectionID 
						withData:(uint8_t *)packet ofLen:(uint16_t)size{
    memcpy(tmp+nb,packet,size);
    nb+=size;
    if ((packet[size-1] == '\0')||(packet[size-1] == '\n')){
		NSString *valp = [[NSString alloc] initWithFormat:@"%d",received];
    	[rfStat performSelectorOnMainThread:@selector(setText:)
            withObject: valp
            waitUntilDone:YES];
        nb = 0;
    }
}
/* Event when a device is selected */
-(BOOL) discoveryView:(BTDiscoveryViewController*)discoveryView willSelectDeviceAtIndex:(int)deviceIndex {
    if (selectedDevice) return NO;
    selectedDevice = [bt deviceAtIndex:deviceIndex];
    BTDevice *device = selectedDevice;
    [bt stopDiscovery];
    [bt createRFCOMMConnectionAtAddress:[device address] withChannel:11 authenticated:NO];
    [nav.view removeFromSuperview];
    //[bt removeListener:inqView];
    return NO;
}
-(void)statusCellSelectedDiscoveryView:(BTDiscoveryViewController*)discoveryView
{
        if (![bt isDiscoveryActive]) {
                selectedDevice = nil;
                        [bt startDiscovery];
                            }
                                NSLog(@"statusCellSelected!");
                               }

- (void)timerFireMethod:(NSTimer*)theTimer {
	sprintf(data_out,"coucou\r\n");
	[bt sendRFCOMMPacketForChannelID:1 packet:(uint8_t *)data_out len:strlen(data_out)];
}
- (void)applicationDidFinishLaunching: (UIApplication *) application {
	selectedDevice = nil;
    window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];
    // create BTInquiryView
    inqView = [[BTDiscoveryViewController alloc] init];
    [inqView setDelegate:self];
    // Override point for customization after application launch
    nav = [[UINavigationController alloc] initWithRootViewController:inqView];

    CGRect windowRect = [ [ UIScreen mainScreen ] applicationFrame ];
    windowRect.origin.x = windowRect.origin.y = 0.0f;

    // Create the window object and assign it to the
    // window instance variable of the application delegate.

    window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    window.backgroundColor = [UIColor whiteColor];

	CGRect txtFrame2 = CGRectMake(110,65,250,150);
	UIFont *font = [UIFont boldSystemFontOfSize:18.0];

	rfStat = [[UITextField alloc] initWithFrame:txtFrame2];
    rfStat.text = @"testGPS";
    rfStat.font = font;

    /*CGRect imgRect2 = CGRectMake(5,5,windowRect.size.width-5,windowRect.size.height-5);
	affSin = [[afficheSinu alloc] 
		initWithFrame: imgRect2];
    [ window  addSubview: affSin ];
*/
	    [window addSubview:rfStat];
    [window addSubview:nav.view];
    timer = [NSTimer scheduledTimerWithTimeInterval:0.7
	            target:self selector:@selector(timerFireMethod:)
				userInfo:nil repeats:YES];
    // Show the window.

    [window makeKeyAndVisible];
   // btstack
   bt = [BTstackManager sharedInstance];
   [bt setDelegate:self];
   [bt addListener:self];
   [bt addListener:inqView];

   [bt activate];
    
}
-(void) activatedBTstackManager:(BTstackManager*) manager {}
-(void) btstackManager:(BTstackManager*)manager activationFailed:(BTstackError)error {};
-(void) discoveryInquiryBTstackManager:(BTstackManager*) manager {
   [bt storeDeviceInfo];
}
-(void) discoveryStoppedBTstackManager:(BTstackManager*) manager {}
-(void) btstackManager:(BTstackManager*)manager discoveryQueryRemoteName:(int)deviceIndex {}
-(void) btstackManager:(BTstackManager*)manager deviceInfo:(BTDevice*)device{}

-(void) btstackManager:(BTstackManager*) manager handlePacketWithType:(uint8_t) packet_type forChannel:(uint16_t) channel
               andData:(uint8_t *)packet withLen:(uint16_t) size {
}


@end

