#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#import <CoreFoundation/CoreFoundation.h>
#import <UIKit/UIKit.h>
#import <UIKit/UIButton.h>
#import <UIKit/UITextView.h>
#import <UIKit/UIFont.h>
#import "dateTest.h"


int main (int argc, char **argv){
	NSAutoreleasePool *autoreleasePool = [[ NSAutoreleasePool alloc ] init ];
	
	int returnCode = UIApplicationMain(argc, argv, @"dateTest", @"dateTest");
	[ autoreleasePool release ];
	return returnCode;
}

@implementation dateTest
- (IBAction) buttonPressed: (id)sender {
	NSDate *formatterDate = [NSDate date];
	NSString *newDateString = [outputFormatter stringFromDate:formatterDate];
		
	[txtaffiche setText:newDateString];
}
- (BOOL) txtdateTestDidEndEditingNotification:(UITextField *) textField {
	return YES;
}
- (void)applicationDidFinishLaunching: (UIApplication *) application {
	outputFormatter = [[NSDateFormatter alloc] init];
	[outputFormatter setDateFormat:@"yyyy_MM_d__HH_mm_ss"];

	window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];

	CGRect windowRect = [ [ UIScreen mainScreen ] applicationFrame ];
	windowRect.origin.x = windowRect.origin.y = 0.0f;

	// Create the window object and assign it to the
	// window instance variable of the application delegate.

	window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
	window.backgroundColor = [UIColor whiteColor];
	
	/* entry */
	CGRect rectdateTest = CGRectMake(50,50,150,150);
	txtdateTest = [[UITextField alloc] initWithFrame:rectdateTest];
	txtdateTest.text = @"dateTest";
	txtdateTest.delegate = self;
	/* button */
	CGRect rectButton = CGRectMake(50,100,150,150);
	button = [[UIButton alloc] initWithFrame:rectButton];
	[ button setTitle: @"validate" forState:UIControlStateNormal];
	[button setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
	[button addTarget:self action:@selector(buttonPressed:) 
			forControlEvents:UIControlEventAllEvents];
	/* final */
	CGRect rectaffiche = CGRectMake(50,250,250,200);
	txtaffiche = [[UILabel alloc] initWithFrame:rectaffiche];
	txtaffiche.text = @"dateTest";
	
	UIFont *font = [UIFont boldSystemFontOfSize:18.0];
	txtdateTest.font = font;
	txtaffiche.font = font;

	[ window  addSubview: txtdateTest ];
	[ window  addSubview: button ];
	[ window  addSubview: txtaffiche ];

	// Show the window.
	[window makeKeyAndVisible];
}

@end

