#import "lego_impl.h"


@implementation lego_impl 

@synthesize rfStat;
@synthesize mess;
@synthesize bt;
@synthesize affSin;

// send beep + 2 ultrasonic init part
char init_nxt[26]={0x06,0x00,0x00,0x03,0xf4,0x01,0xf4,0x01,
			0x05,0x00,0x00,0x05,0x00,0x0b,0x00,
			0x08,0x00,0x00,0x0f,0x00,0x03,0x00,0x02,0x41,0x02};
char beep[8]={0x06,0x00,0x00,0x03,0xf4,0x01,0xf4,0x01};//beep
char ultra1[7]={0x05,0x00,0x00,0x05,0x00,0x0b,0x00}; // init ultrasonic part1
char ultra2[10]= {0x08,0x00,0x00,0x0f,0x00,0x03,0x00,0x02,0x41,0x02}; // init ultrasonic part2

- (id) init {
	self = [super init];
	start = 0;
	rfStat = NULL;
	mess = NULL;
	bt = NULL;
	return self;
}
 -(void)sendInit {
	mess.text = @"ok";
	[bt sendRFCOMMPacketForChannelID: 1 packet: (uint8_t *) init_nxt len:sizeof(init_nxt)];
	start =1;
}
-(int)isInit {
	return (start==1);
}
 -(void)receiveFromBt:(uint8_t*) packet ofLen:(uint16_t) size
{
	char toto[10];
	NSString *str;// = [[NSString alloc] initWithFormat:@"%d",(int)size];
	  //  [rfStat performSelectorOnMainThread:@selector(setText:)
        //    withObject: str
         //   waitUntilDone:YES];
	/*if (size > 5) {	
		sprintf(toto,"%d %d %d %d\n",packet[0],packet[2],packet[3], packet[4]);
		NSString *str2 = [[NSString alloc] initWithCString:(char*)toto encoding : 1];
		[mess performSelectorOnMainThread:@selector(setText:)
	        withObject: str2
	        waitUntilDone:YES];
	}*/
	/*if (packet[2] == 0x02 && packet[3] == 0x0F) {
		if (packet[0]==	3 && packet[4] == 0x00) {
				[mess performSelectorOnMainThread:@selector(setText:)
         			withObject: @"init"
           			waitUntilDone:YES];
			start = 1;
			return;
		}
	}*/
	if (packet[2] == 0x02 && packet[3] == 0x10) {
		start = 1;
		// packet[6] => distance
		str = [[NSString alloc] initWithFormat:@"%d",(int)packet[6]];
		/*NSString**/// str2 = [[NSString alloc] initWithCString:(char*)&c encoding : 1];
		//NSString *str2 = [[NSString alloc] initWithCString:(char*)packet+4 encoding : 1];
		CGFloat val = [str doubleValue];
		[affSin addPoint: val];
	    [rfStat performSelectorOnMainThread:@selector(setText:)
            withObject: str
            waitUntilDone:YES];

	}
}

/* Accelero callback */
- (void)sendCmd:(float )accX accY:(float)accY
{	
	//if (start ==0 ) return;
	char vx = (char)(accX*100);
	char vy = (char)(accY*100);
	char gauche=0, droite = 0;
		droite = gauche = vx; 
	if (vy <-0) 		droite = vx+vy;
	else if (vy > 0) 	gauche = vx-vy;
	char test[30+9+5]={0x0d,0x00,0x80/*0x00*/,0x04,0x00,droite,1+4,1,0x00,0x20,0,0,0,0,0
  		,0x0d,0x00,0x80/*0x00*/,0x04,0x02,gauche,1+4,1,0x00,0x20,0,0,0,0,0
		/* for ultrasonor */
		,0x07,0x00,0x00,0x0f,0x00,0x02,0x08,0x02,0x42
		,0x03,0x00,0x00,0x10,0x00};
	[bt sendRFCOMMPacketForChannelID: 1 packet: (uint8_t *) test len:sizeof(test)];
}
@end
