#import <CoreFoundation/CoreFoundation.h>
//#import <ApplicationServices/ApplicationServices.h>
#import <CoreGraphics/CGContext.h>
#import <UIKit/UIKit.h>
#import <UIKit/UITextView.h>
#import <UIKit/UIFont.h>
//#import <NSGraphicsContext.h>
#import <math.h>
#import "afficheSinu.h"

static inline CGFloat radians (CGFloat degrees) {return degrees * M_PI/180.;}

@implementation afficheSinu

@synthesize arrayPoints;
@synthesize arraySize;

- (id)init {
	self = [super init];
	arrayPoints = [[NSMutableArray alloc] initWithCapacity: 128];
	arraySize = 0;
	return self;
}

- (id)initWithFrame:(CGRect )frame {
	self = [super initWithFrame: frame];
	arrayPoints = [[NSMutableArray alloc] initWithCapacity: 128];
	arraySize = 0;
	return self;
}

-(void)addPoint:(CGFloat) point {
	NSNumber *nb = [NSNumber numberWithFloat: point];
	if (arraySize == 127) 
		[arrayPoints removeObjectAtIndex:0];
	else 
		arraySize ++;

	[arrayPoints addObject:nb];
	[self setNeedsDisplay];
}
-(void)drawRect:(CGRect)rect
{
	CGRect imgRect = [self bounds];
 	CGContextRef context = UIGraphicsGetCurrentContext();
    CGContextSetLineWidth(context, 10);
	[[UIColor whiteColor] set];

	CGFloat orig=imgRect.size.width/2;
	CGFloat x=imgRect.size.width/2;
	CGFloat decalY = imgRect.size.height/128;//256;

	const CGFloat truc[] = {1.,1.,1.};
	CGContextSetRGBFillColor (context, 0, 1, 0, 1);
	CGContextFillRect (context, imgRect);// 4

	CGContextSetRGBFillColor (context, 0, 0, 1, 1);
	CGContextSetLineWidth(context,3);
	//CGContextSetFillColor(context,truc);
	//
	UIRectFrame(imgRect);
    //CGContextSetRGBFillColor (context, 1, 0, 0, 1);// 3

	//CGContextFillRect (context, CGRectMake (0, 0, 200, 100 ));
	//CGFloat y=imgRect.size.height/2;
	int i;
	CGContextBeginPath (context);
	NSNumber *nb;
	NSNumber *nb1;

	for (i=1;i<arraySize;i++) {
		//something
		nb = [arrayPoints objectAtIndex:i];
		nb1 = [arrayPoints objectAtIndex:i-1];
	    CGContextMoveToPoint(context, x+[nb1 floatValue]*orig, (i-1)*decalY);

	    CGContextAddLineToPoint(context, x+[nb floatValue]*orig,i*decalY);
	}
	CGContextStrokePath(context);
	/*CGFloat tx = x-(x*cosf(angl)+y*sinf(angl));
    CGFloat ty = y+(x*sinf(angl)-y*cosf(angl));

	CGContextTranslateCTM (myContext, tx, ty);
	CGContextRotateCTM(myContext, - angl);
	CGContextDrawImage(myContext, imgRect, imageRef);*/
}
- (void) refresh {
	[self setNeedsDisplay]; 
}
@end

